// Modifications:
//  - Matrix matrix multiplication via the Matrix class/interface
//  - Element-wise multiplication of an arbitrary number of matrixes

#include <ostream>
#include <octave/oct.h>

DEFUN_DLD(product_cpp, args, nargout,
          "-*- texinfo -*-\n"
          "@deftypefn {FunctionFile} {} product_cpp (@var{x},@var{y})\n"
          "\n"
          "Element-wise multiplication of @var{x} and @var{y}.\n"
          "@end deftypefn") {
  octave_value_list retval;

  // Check and extract the arguments
  if (args.length() !=2 || !args(0).is_matrix_type() || !args(1).is_matrix_type()) {
    print_usage();
    return octave_value();
  }

  NDArray x = args(0).matrix_value();
  NDArray y = args(1).matrix_value();

  // Peform and return the element-wise multiplication
  retval(0) = product(x,y);
  return retval;
}
